DECLARE SUB COMLINE (NUMARGS%, ARGS$(), MAXARGS%)
DECLARE FUNCTION POLYAREA! (numverts%, polygon() AS ANY)
DECLARE SUB FREEFORM (LINE$, NUMFORM!, FORM$())
DECLARE FUNCTION THETA! (P1 AS ANY, P2 AS ANY)
DECLARE FUNCTION WRAP% (polygon() AS ANY, T AS ANY, N%)
DIM TREES(1 TO 2, 1 TO 100) AS SINGLE   'trees holds the tree coordinates
DIM FORM$(1 TO 100)
DIM COM$(1 TO 20)


TYPE PNT              'point coordinate data type
  x AS SINGLE
  y AS SINGLE
END TYPE

DIM polygon(1 TO 100) AS PNT      'array to hold the veritices of the polygon

COMMON T AS PNT
COMMON polygon() AS PNT

CALL COMLINE(N%, COM$(), 1)      'get command line argument(a filename)
FILE$ = COM$(1)
IF N% = 0 THEN                   'if no argument get file name
  INPUT "ENTER DATA FILE NAME AND EXTENSION:     ", FILE$
END IF

ON ERROR GOTO 100

50 OPEN FILE$ FOR INPUT AS #1     'open the input data file
GOTO 200                       'if no error

100 INPUT "FILE NOT FOUND.. FILENAME:  ", FILE$  'file error handler
    RESUME 50
    

200 LINE INPUT #1, LINE$
numtrees% = 0

DO                                        'this loop reads the tree coordinates & initializes arrays
  numtrees% = numtrees% + 1
  CALL FREEFORM(LINE$, NUM, FORM$())      'freeform parses the string
  TREES(1, numtrees%) = VAL(FORM$(1))
  polygon(numtrees%).x = VAL(FORM$(1))
  TREES(2, numtrees%) = VAL(FORM$(2))
  polygon(numtrees%).y = VAL(FORM$(2))
  LINE INPUT #1, LINE$
LOOP UNTIL LINE$ = ""
   
numverts% = WRAP%(polygon(), T, numtrees%)          'wrap finds the convex hull and returns the number of vertices in the hull
polygon(numverts% + 1) = polygon(1)

TOTAL! = (POLYAREA!(numverts%, polygon()) / 43560)   'polyarea returns the area ot the hull in square feet


OPEN "FIREAREA.DAT" FOR OUTPUT AS #3              'data output file

PRINT #3, "TOTAL AREA =", TOTAL!
PRINT #3, ""
PRINT #3, "YEAR", "AREA", "AREA/TOTAL", "      # FIRES"

NUMYEARS% = 1
LINE INPUT #1, LINE$


DO               'this loop steps through the years

  FOR i% = 1 TO 100       'initialize polygon
    polygon(i%).x = 0
    polygon(i%).y = 0
  NEXT

  NUMFIRES% = 0
  CALL FREEFORM(LINE$, NUM, FORM$())

  FOR i% = 2 TO numtrees% + 1                  'this loop steps through the fires in a year

    IF FORM$(i%) = "1" THEN                    'if a tree has a fire its coordinates become part of the polygon
      NUMFIRES% = NUMFIRES% + 1
      polygon(NUMFIRES%).x = TREES(1, i% - 1)
      polygon(NUMFIRES%).y = TREES(2, i% - 1)
    END IF

  NEXT

  IF NUMFIRES% >= 3 THEN                              'if the fires form a polygon the convex hull is found and the area
    numverts% = WRAP%(polygon(), T, NUMFIRES%)        'is clculated
    polygon(numverts% + 1) = polygon(1)
    AREA! = (POLYAREA!(numverts%, polygon()) / 43560)

    IF AREA! < 1 THEN
      AREA! = 1
    END IF

  END IF

  IF NUMFIRES% = 1 THEN       'minimum area for 1 fire
    AREA! = 1
  END IF

  IF NUMFIRES% = 2 THEN      'area is calculated using the distance between the 2 points as the diameter of a circle
   AREA! = (SQR((polygon(1).x - polygon(2).x) * (polygon(1).x - polygon(2).x) + (polygon(1).y - polygon(2).y) * (polygon(1).y - polygon(2).y))) * 3.1416 / 43560
  
   IF AREA! < 1 THEN
     AREA! = 1
   END IF

  END IF

  IF NUMFIRES% = 0 THEN
    AREA! = 0
  END IF

  PRINT #3, FORM$(1), AREA!, AREA! / TOTAL!, NUMFIRES%
  NUMYEARS% = NUMYEARS% + 1
  LINE INPUT #1, LINE$

LOOP UNTIL EOF(1)

CLOSE #3
END




SUB COMLINE (NUMARGS%, ARGS$(), MAXARGS%) STATIC
' Subroutine to get command line and split into arguments.
' Parameters:  NUMARGS% : Number of command line args found.
'              Args$() : Array in which to return arguments.
'              MAXARGS% : Maximum number of arguments array
'                        can return.

CONST TRUE = -1, FALSE = 0

   NUMARGS% = 0: In = FALSE
' Get the command line using the COMMAND$ function.
   Cl$ = COMMAND$
   L = LEN(Cl$)
' Go through the command line a character at a time.
   FOR i = 1 TO L
      C$ = MID$(Cl$, i, 1)
    'Test for character being a blank or a tab.
      IF (C$ <> " " AND C$ <> CHR$(9)) THEN
    ' Neither blank nor tab.
    ' Test to see if you're already
    ' inside an argument.
         IF NOT In THEN
      ' You've found the start of a new argument.
      ' Test for too many arguments.
            IF NUMARGS% = MAXARGS% THEN EXIT FOR
            NUMARGS% = NUMARGS% + 1
            In = TRUE
         END IF
     ' Add the character to the current argument.
         ARGS$(NUMARGS%) = ARGS$(NUMARGS%) + C$
      ELSE
   ' Found a blank or a tab.
   ' Set "Not in an argument" flag to FALSE.
         In = FALSE
      END IF
   NEXT i
'
END SUB

SUB FREEFORM (LINE$, NUMFORM, FORM$())
A$ = LINE$ + " "
NUMFORM = 0
  WHILE LEN(A$) > 0
  NUMFORM = NUMFORM + 1
        WHILE LEFT$(A$, 1) = " "
        A$ = RIGHT$(A$, LEN(A$) - 1)
        WEND
  IF LEN(A$) = 0 THEN A$ = " "
  C = INSTR(A$, " ")
  FORM$(NUMFORM) = LEFT$(A$, C - 1)
  A$ = RIGHT$(A$, LEN(A$) - C)
  WEND

END SUB

FUNCTION POLYAREA! (numverts%, polygon() AS PNT)

AREA! = 0!

FOR i% = 1 TO numverts%
   AREA! = AREA! + polygon(i%).x * polygon(i% + 1).y
NEXT

FOR i% = 1 TO numverts%
  AREA! = AREA! - polygon(i% + 1).x * polygon(i%).y
NEXT

POLYAREA! = .5 * AREA!

END FUNCTION

FUNCTION THETA! (P1 AS PNT, P2 AS PNT)

  DX! = P2.x - P1.x
  AX! = ABS(DX!)
  DY! = P2.y - P1.y
  AY! = ABS(DY!)

  IF (DX! = 0) AND (DY! = 0) THEN
    T = 0
  ELSE T = DY! / (AX! + AY!)
  END IF

  IF DX! < 0 THEN
    T = 2 - T
  ELSEIF DY! < 0 THEN
    T = 4 + T
  END IF

  THETA = T * 90!

END FUNCTION

FUNCTION WRAP% (polygon() AS PNT, T AS PNT, N%)


  MIN% = 1

  FOR i% = 2 TO N%
    IF polygon(i%).y < polygon(MIN%).y THEN
      MIN% = i%
    END IF

    M% = 0
    polygon(N% + 1) = polygon(MIN%)
    MINANGLE! = 0!
  NEXT

    DO
      M% = M% + 1
      T = polygon(M%)
      polygon(M%) = polygon(MIN%)
      polygon(MIN%) = T
      MIN% = N% + 1
      V! = MINANGLE!
      MINANGLE! = 360!

      FOR i% = M% + 1 TO N% + 1
        IF THETA(polygon(M%), polygon(i%)) > V! THEN
          IF THETA(polygon(M%), polygon(i%)) < MINANGLE! THEN
            MIN% = i%
            MINANGLE! = THETA(polygon(M%), polygon(MIN%))
          
          END IF
        END IF
     NEXT

    LOOP UNTIL MIN% = N% + 1
    WRAP% = M%


END FUNCTION

